Set-StrictMode -Version latest
$line = Get-Content -Path $PSScriptRoot\input
$stones = $line -split ' '

$stones = $stones | ForEach-Object -ThrottleLimit 100 -Parallel {
$stones = @($_)
function Memoize($func) {
    $cachedResults = @{}
    {
        if (-not $cachedResults.ContainsKey($args[0])) {
            $cachedResults.Add($args[0],$func.invoke($args))
        }
        $cachedResults[$args[0]]
    }.getnewclosure()
}

function blinkStone {
    param([string]$stone)
    if($stone -eq '0') {
        return @('1')
    } elseif($stone.Length%2 -eq 0) {
        $length = $stone.Length
        $mid = $length/2
        $first = [string][int]$stone.Substring(0,$mid)
        $second = [string][int]$stone.Substring($mid)
        return @($first, $second)
    } else {
        return @([string](([int]$stone)*2024))
    }
}
$blinkStone = Memoize ${function:blinkStone}
function blink {
    param($stones)
    return $stones | ForEach-Object {
        return &$blinkStone $_
    }
    return $response
}

for($i=0;$i -lt 25; $i++){
    $stones = blink($stones)
}
return $stones
}

#$stones
$stones.Length