$lines = Get-Content -Path $PSScriptRoot\input
$games = $lines -join "`n" -split "`n`n"

function Find-MinimumXY {
    param (
        [int]$a1,
        [int]$a2,
        [int]$a,
        [int]$b1,
        [int]$b2,
        [int]$b
    )

    $minSum = [Int32]::MaxValue
    $minSet = $false

    $yMax = [math]::Floor($b / $b2)
    if($yMax -gt 100) {
        $yMax = 100
    }
    for ($y = 0; $y -le $yMax; $y++) {
        for ($x = 0; $x -le 100; $x++) {
            if ($x * $a1 + $y * $a2 -eq $a -and $x * $b1 + $y * $b2 -eq $b) {
                $sum = $x * 3 + $y
                if ($sum -lt $minSum) {
                    $minSum = $sum
                    $minSet = $true
                }
            }
        }
    }
    if ($minSet) {
        return $minSum
    } else {
        return 0
    }
}

$results = $games | ForEach-Object {
    $game = $_
    $lines = $game -split "`n" -split ": " -split ", " -split "\+" -split "="
    $buttonA = @([int]$lines[2], [int]$lines[4])
    $buttonB = @([int]$lines[7], [int]$lines[9])
    $price = @([int]$lines[12], [int]$lines[14])
    Write-Host "$buttonA, $buttonB, $price"
    return Find-MinimumXY -a1 $buttonA[0] -a2 $buttonB[0] -a $price[0] -b1 $buttonA[1] -b2 $buttonB[1] -b $price[1]
}
$measurements = $results | measure-object -sum
Write-Host $measurements.sum