Set-StrictMode -Version latest
$lines = Get-Content -Path $PSScriptRoot\input
$robots = $lines | ForEach-Object {
    $line = $_
    #p=0,4 v=3,-3
    $parts = $line -split "=" -split "," -split " "
    Write-Host $parts
    return [PSCustomObject]@{
        'x' = [int]$parts[1]
        'y' = [int]$parts[2]
        'vx' = [int]$parts[4]
        'vy' = [int]$parts[5]
    }
}
$height=103
$width=101
$steps=100
$robots | ForEach-Object {
    $_.x += $_.vx * $steps
    $_.y += $_.vy * $steps

    $_.x = $_.x % $width
    $_.y = $_.y % $height

    if($_.x -lt 0) {
        $_.x += $width
    }
    if($_.y -lt 0) {
        $_.y += $height
    }
}
$centerX = [math]::Floor($width/2)
$centerY = [math]::Floor($height/2)
function drawRobots {
    param($robots)
    for($y=0;$y -lt $height; $y++) {
        $line=""
        if($y -ne $centerY) {
            for($x=0;$x -lt $width; $x++) {
                if($x -eq $centerX) {
                    $line+=" "
                } else {
                $filtered = $robots | Where-Object {$_.y -eq $y -and $_.x -eq $x}
                    if($null -eq $filtered) {
                        $line+="."
                    } else {
                        $line+=$filtered.Length
                    }
                }
            }
        }
        Write-Host $line
    }    
}
drawRobots($robots)
Write-Host $centerX, $centerY

$topLeft=0
$topRight=0
$bottomLeft=0
$bottomRight=0
$robots | ForEach-Object {
    if($_.x -eq $centerX -or $_.y -eq $centerY) {} else {
        $top = $_.y -lt $centerY
        $bottom = $_.y -gt $centerY
        $left = $_.x -lt $centerX
        $right = $_.x -gt $centerX
        if($top -and $left) {
            $topLeft++
        }
        if($top -and $right) {
            $topRight++
        }
        if($bottom -and $left) {
            $bottomLeft++
        }
        if($bottom -and $right) {
            $bottomRight++
        }
    }
}
Write-Host $topLeft, $topRight, $bottomLeft, $bottomRight
$result = $topLeft*$topRight*$bottomLeft*$bottomRight
Write-Host $result