Set-StrictMode -Version latest
$lines = Get-Content -Path $PSScriptRoot\input | Select -First 1024
$xSize=70
$ySize=70

$grid=@()
for($y=0;$y -le $ySize;$y++) {
    $line=@()
    for($x=0;$x -le $xSize;$x++) {
        $line+="."
    }
    $grid+=,$line
}
function drawGrid {
    $grid | ForEach-Object {
        $_ -join ' ' | Write-Host 
    }
}

$lines | ForEach-Object {
    $parts = $_ -split ','
    [int]$x=$parts[0]
    [int]$y=$parts[1]
    $grid[$y][$x]="#"
}

$grid[0][0]=0
function getValue {
    param($x,$y, $xOffset, $yOffset)
    $x+=$xOffset
    $y+=$yOffset
    if($y -gt $ySize -or $x -gt $xSize) {
        return 100000
    }
    $value = $grid[$y][$x]
    if($value -eq "#" -or $value -eq ".") {
        $value = 100000
    }
    return $value
}

function doCell {
    param($x, $y)
    $current=$grid[$y][$x]
    if($current -eq "#") {
        return $false
    }
    if($current -eq ".") {
        $current = 100000
    }
    $numbers = @($current)
    $numbers+=getValue $x $y 0 -1
    $numbers+=getValue $x $y 0 1
    $numbers+=getValue $x $y -1 0
    $numbers+=getValue $x $y 1 0

    $measurement = $numbers | measure-object -Minimum
    $min = $measurement.Minimum
    $min += 1
    if($current -gt $min) {
        $grid[$y][$x]=$min
        $cellsChanged+=1
        return $true
    } else {
        return $false
    }
}
$changed=1
while($changed -ge 1) {
    $changed=0
    for($y=0;$y -le $ySize;$y++) {
        for($x=0;$x -le $xSize;$x++) {
            $singleChanged = doCell $x $y
            if($singleChanged) {
                $changed+=1
            }
        }
        for($x=$xSize;$x -ge 0;$x--) {
            $singleChanged = doCell $x $y
            if($singleChanged) {
                $changed+=1
            }
        }
    }
    for($y=$ySize;$y -ge 0;$y--) {
        for($x=0;$x -le $xSize;$x++) {
            $singleChanged = doCell $x $y
            if($singleChanged) {
                $changed+=1
            }
        }
        for($x=$xSize;$x -ge 0;$x--) {
            $singleChanged = doCell $x $y
            if($singleChanged) {
                $changed+=1
            }
        }
    }
    Write-Host "$changed cells changed"
}

$solution = $grid[$ySize][$xSize]
Write-Host "solution: $solution"