Set-StrictMode -Version latest
$lines = Get-Content -Path $PSScriptRoot\input
$validCounter = 0
$part2 = $true
function checkLine {
    param ($parts)
    $direction = [int]$parts[1] -gt [int]$parts[0]
    $previous = $parts[0]
    $previous = [int]$previous
    $valid = $true
    forEach ($new in $parts | Select-Object -Skip 1) {
        $new = [int]$new
        $difference = $new - $previous
        if($direction) {
            # Increasing
            if ($difference -lt 1 -or $difference -gt 3) {
                $valid = $false
            }
        } else {
            # Decreasing
            if ($difference -gt -1 -or $difference -lt -3) {
                $valid = $false
            }
        }
        $previous = $new
    }
    return $valid
}
ForEach ($line in $lines)
{
    $parts = $line -split " "
    $parts = $parts | Where-Object { $_ } #Remove empty items (spaces)
    $foundValid = checkLine($parts)
    if ($part2) {
        for($i=0;$i -lt $parts.Length; $i++) {
            $partsClone = [System.Collections.ArrayList]($parts)
            $partsClone.RemoveAt($i)
            if(checkLine($partsClone)) {
                $foundValid = $true
            }
        }
    }
    if($foundValid) {
        $validCounter++;
    }
}
Write-Host $validCounter