Set-StrictMode -Version latest
$lines = Get-Content -Path $PSScriptRoot\input
$count = 0
$ErrorActionPreference= 'silentlycontinue'
function checkLineSingle {
    param ($line)
    Write-Host $line
    while ($line.Length -ge 4) {
        $part = $line.Substring(0,4)
        if($part -eq "XMAS") {
            $script:count++
        }
        $line = $line.Remove(0,1)
    }
}
function checkLine {
    param ($line)
    $line = $line | Where-Object { $_ }
    checkLineSingle($line)
    $reversed = $line[-1..-$line.Length] -join ''
    checkLineSingle($reversed)
}
#horizontal
for($x=0;$x -lt $lines.Length;$x++) {
    checkLine($lines[$x]);
}
#vertical
for ($x=0;$x -lt $lines[0].Length;$x++) {
    $line = ""
    for($y=0;$y -lt $lines.Length;$y++) {
        $line += $lines[$y][$x]
    }
    checkLine($line);
}
for($x=-$lines.Length;$x -lt $lines.Length+2;$x++) {
    $line="";
    $line2="";
    for($x2=0;$x2 -le $lines.Length+2;$x2++) {
        #Will give out of bounds errors, but ps just continues.
        if ($x+$x2 -ge 0) {
            $line += $lines[$x2][$x+$x2]
        }
        if ($lines.Length-$x-$x2 -ge 0) {
            $line2 += $lines[$x2][$lines.Length-$x-$x2]
        }
    }
    checkLine($line)
    checkLine($line2)
}

Write-Host $count