Set-StrictMode -Version latest
$lines = Get-Content -Path $PSScriptRoot\input
$parts = $lines -join'`n' -split'`n`n'
$orderingLines=$parts[0] -split '`n'
$updateLines=$parts[1] -split '`n'
$ordering = @{}
$orderingLines | ForEach-Object {
    $parts = $_ -split '\|'
    if($null -eq $ordering[$parts[0]]) {
        $ordering[$parts[0]] = @()
    }
    $ordering[$parts[0]] += $parts[1]
}

$comparison = [System.Comparison[Object]]{
    param($x, $y)
    
    if($null -ne $ordering[$x] -and $y -in $ordering[$x]) {
        return -1
    }
    if($null -ne $ordering[$y] -and $x -in $ordering[$y]) {
        return 1
    }
    return 0
}

$sumUnchanged = 0
$sumChanged = 0
$updateLines | ForEach-Object {
    $item = $_ -split ','
    [Array]::Sort($item, $comparison)
    $middleIndex = ($item.Length-1)/2
    $middle = $item[$middleIndex]

    $changed = $item -join ',' -ne $_
    if($changed) {
        $sumChanged += $middle
    } else {
        $sumUnchanged += $middle
    }
}
Write-Host "part1: $sumUnchanged"
Write-Host "part2: $sumChanged"
