Set-StrictMode -Version latest
$lines = Get-Content -Path $PSScriptRoot\input
$position = @{
    x=0
    y=0
}
$direction = @{
    x=0
    y=-1
}
for($y=0;$y -lt $lines.Length; $y++) {
    for($x=0;$x -lt $lines[0].Length; $x++) {
        $currentValue = $lines[$y][$x]
        if($currentValue -eq "." -or $currentValue -eq "#") {
            continue
        }
        $position = @{
            x=$x
            y=$y
        }
        if($currentValue -ne "^") {
            Write-Host "starting point isnt up!"
            exit 1
        }
    }
}
$position | ConvertTo-Json | Out-File $PSScriptRoot\position

$line = $lines[$position.y]
$line = $line -Split "" | Where-Object { $_ }
$line[$position.x] = "."
$line = $line -join ""
$lines[$position.y] = $line

$coveredCells=@()
while($true) {
    $line = $lines[$position.y]
    $line = $line -Split "" | Where-Object { $_ }
    $line[$position.x] = "X"
    $line = $line -join ""
    $lines[$position.y] = $line
    $x = $position.x+$direction.x
    $y = $position.y+$direction.y
    if($x -lt 0 -or $x -ge $lines[0].Length -or $y -lt 0 -or $y -ge $lines.Length) {
        break
    }
    if($lines[$y][$x] -eq "#") {
        if($direction.x -eq 1) {
            $direction.x = 0
            $direction.y = 1
        } elseif ($direction.y -eq 1) {
            $direction.x = -1
            $direction.y = 0
        } elseif ($direction.x -eq -1) {
            $direction.x = 0
            $direction.y = -1
        } elseif ($direction.y -eq -1) {
            $direction.x = 1
            $direction.y = 0
        } else {
            Write-Host "unknown direction $direction"
            exit 1
        }
    } else {
        $coveredCells+="$($position.y),$($position.x)"
        $position.y+=$direction.y
        $position.x+=$direction.x
        $coveredCells+="$($position.y),$($position.x)"
    }
}
$unique = $coveredCells | Sort-Object | Select-Object -Unique
$unique | Out-File $PSScriptRoot\unique
$unique.Length