Set-StrictMode -Version latest
$linesOriginal = Get-Content -Path $PSScriptRoot\input | ConvertTo-Json
$unique = Get-Content -Path $PSScriptRoot\unique
$total = $unique.Length
$originalPosition = Get-Content -Path $PSScriptRoot\position
$checked = 0
$withLoop = @()
$unique | ForEach-Object {
    $lines = $linesOriginal | ConvertFrom-Json
    $parts = $_ -split ","
    $line = $lines[$parts[0]]
    $line = $line -Split "" | Where-Object { $_ }
    $line[$parts[1]] = "#"
    $line = $line -join ""
    $lines[$parts[0]] = $line
    $position = $originalPosition | ConvertFrom-Json
    $direction = @{
        x=0
        y=-1
    }
    $seen=@()
    while($true) {
        $x = $position.x+$direction.x
        $y = $position.y+$direction.y
        if($x -lt 0 -or $x -ge $lines[0].Length -or $y -lt 0 -or $y -ge $lines.Length) {
            break
        }
        if($lines[$y][$x] -eq "#") {
            $pos = "$($position.y),$($position.x)"
            if($seen -Contains $pos -and $seen[-1] -ne $pos) {
                Write-Host "found loop!"
                $withLoop+=$_
                break
            }
            $seen+=$pos
            if($direction.x -eq 1) {
                $direction.x = 0
                $direction.y = 1
            } elseif ($direction.y -eq 1) {
                $direction.x = -1
                $direction.y = 0
            } elseif ($direction.x -eq -1) {
                $direction.x = 0
                $direction.y = -1
            } elseif ($direction.y -eq -1) {
                $direction.x = 1
                $direction.y = 0
            } else {
                Write-Host "unknown direction $direction"
                exit 1
            }
        } else {
            $position.y+=$direction.y
            $position.x+=$direction.x
        }
    }
    $checked++
    Write-Host "$checked/$total"
}
$withLoop.Count