Set-StrictMode -Version latest
$part2 = $true
$lines = Get-Content -Path $PSScriptRoot\input

$sums = $lines | ForEach-Object -ThrottleLimit 10 -Parallel {
    $parts = $_ -split ': '
    $target = [int64]::parse($parts[0])
    $numbers = $parts[1] -split ' ' | % {[int64]::parse($_)}
    [array]::Reverse($numbers)

    
    function findOperands {
        param($numbers)
        $first, $rest = $numbers
        if($null -eq $rest) {
            return @($first)
        }
        $next = findOperands($rest)
        $response = @()
    
        $next | ForEach-Object {
            $response += $_ * $first
            $response += $_ + $first
            if($part2) {
                $response += [int64]("$_$first")
            }
        }
        $filtered = @()
        $response | ForEach-Object {
            if($_ -le $target) {
                $filtered+=$_
            }
        }
        return $filtered
    }
    $options = findOperands($numbers)
    if($target -in $options) {
        Write-Host "valid"
        return $target
    } else {
        Write-Host "invalid"
        return 0
    }
}

$sum = $sums | measure-object -sum
Write-Host $sum.sum