Set-StrictMode -Version latest
$lines = Get-Content -Path $PSScriptRoot\input
$filesystem = @()
$filesystem = [System.Collections.ArrayList]$filesystem
$doingFile=$true
$fileCount=0
$chars = $lines -split ''
$charCount = $chars.Length
$charsDone=0
$chars | Where-Object { $_ } | ForEach-Object {
    $charsDone++
    if($charsDone % 100 -eq 0) {
        Write-Host "$charsDone/$charCount"
    }
    $item = @()
    if($doingFile) {
        for($i=0;$i -lt $_;$i++) {
            $item+=$fileCount
        }
        $fileCount++
    } else {
        for($i=0;$i -lt $_;$i++) {
            $item+="E"
        }
    }
    $filesystem.addRange($item)
    $doingFile=!$doingFile
}
Write-Host $filesystem
$filesystem | ConvertTo-Json | Out-File 9_first

$filesystem = Get-Content 9_first | ConvertFrom-Json
$eChars = $filesystem | Where-Object { $_ -eq "E" }
$eCount = $eChars.Length
$eDone=0
$counter = [pscustomobject] @{ Value = 0 }
$groupSize = 100
[System.Collections.ArrayList]$groups = @()
$filesystem | Group-Object -Property { [math]::Floor($counter.Value++ / $groupSize) } | ForEach-Object { 
    $groups+= , [System.Collections.ArrayList]$_.Group 
}
[System.Collections.ArrayList]$groupsDone = @()
[System.Collections.ArrayList]$currentGroup=@()
[System.Collections.ArrayList]$lastGroup=@()
while($true) {
    if('E' -in $currentGroup) {} else {
        $groupsDone += , $currentGroup
        if($groups.Count -eq 0) {
            break
        }
        $currentGroup=$groups[0]
        $groups.removeAt(0)
        continue
    }
    if($lastGroup.Count -eq 0) {
        if($groups.Count -eq 0) {
            break
        }
        $lastGroup = $groups[-1]
        $groups.removeAt($groups.Count - 1)
        continue
    }
    $eDone++
    if($eDone % 100 -eq 0) {
        Write-Host "$eDone/$eCount"
    }
    $currentGroup[$currentGroup.indexOf("E")] = $lastGroup[-1]
    $lastGroup.removeAt($lastGroup.Count - 1)
}
[System.Collections.ArrayList]$finalGroup=@()
if($lastGroup.Count -eq 0) {
    $finalGroup=$currentGroup
} else {
    $finalGroup=$lastGroup
}
while('E' -in $finalGroup) {
    $finalGroup[$finalGroup.indexOf('E')] = $finalGroup[-1]
    $finalGroup.removeAt($finalGroup.Count - 1)
}
$groupsDone += , $finalGroup
Write-Host "done, saving"
$groupsDone | ConvertTo-Json | Out-File 9_second
$filesystem = $groupsDone | ForEach-Object {$_}
$filesystem | ConvertTo-Json | Out-File 9_filesystem
$filesystem = Get-Content 9_filesystem | ConvertFrom-Json
Write-Host "start hash"

[System.Collections.ArrayList]$groups = @()
[System.Collections.ArrayList]$hashes = @()
for($i=0;$i -lt $filesystem.Count; $i++) {
    if($hashes.Count -eq 100) {
        $groups += , $hashes
        $hashes = @()
    }
    $hashes+=$filesystem[$i] * $i
}
$groups += , $hashes
$hashes = $groups | ForEach-Object {$_}
$hashes | ConvertTo-Json | Out-File 9_hashes
$checksum = $hashes | measure-object -sum
Write-Host $checksum.sum